// Exercice Ajax
console.log('index.js');

//// Variables
const CLE_API_METEO = 'c57e6567b8cca9291d66a7f600a4fa12';

/// Récupération des éléments html
let formHTML = document.querySelector('#form');
let loadedContentHTML = document.querySelector('#loaded-content');
// console.log(formHTML);
// console.log(loadedContentHTML);

// 0. Envoi du formulaire + preventDefault
formHTML.addEventListener("submit", onSubmit);

// Lors de l'envoi du formulaire
function onSubmit(event) {
    event.preventDefault();

    // console.log("onSubmit");

    // 1.3 Récupération la valeur du bouton radio sélectionné
    let radioSelectedHTML = formHTML.querySelector("input[type=radio]:checked");
    let valeur = radioSelectedHTML.value;

    // Quel bouton à été selectionné ?
    switch(valeur) {
        case 'html' :
            // call ajax correspondant
            // console.log("html");

            ajax('php/1-get-html-article.php')
                .then(function (response) {
                    // Le serveur a correctement répondu
                    // console.log(response);
                    loadedContentHTML.innerHTML = response;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                });
            break;
        
        case 'json' :
            // call ajax correspondant
            // console.log("json");
            ajax('php/2-get-json-data.php')
                .then(function (response) {
                    // Attention, la réponse est en JSON (texte !)
                    // console.log(response);
                    // console.log(typeof response);
                    let responseEnObjet = JSON.parse(response);
                    // console.log(responseEnObjet);

                    // Et on génère le HTML à la volée
                    let chaine = `<ul>`;

                    // Pour chaque contact..
                    for(contact of responseEnObjet) {
                        // .. on crée un <li>
                        chaine += `<li>Je m'apelle <strong>${contact.firstName}</strong> et mon 06 c'est : ${contact.phone}</li>`;
                    }

                    chaine += `</ul>`;

                    loadedContentHTML.innerHTML = chaine;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                });
            break;
        
        case 'movies' :
            // call ajax correspondant
            // console.log("movies");
            ajax('php/3-get-html-movies.php')
                .then(function (response) {
                    // Le serveur a correctement répondu
                    // console.log(response);
                    loadedContentHTML.innerHTML = response;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                });
            
            break;
        
        case 'fake':
            // https://jsonplaceholder.typicode.com/
            // Récupérer les photos de l'album 1
            ajax('https://jsonplaceholder.typicode.com/albums/1/photos')
                .then(function (response) {
                    // Attention, la réponse est en JSON (texte !)
                    // console.log(response);
                    // console.log(typeof response);
                    let responseEnObjet = JSON.parse(response);
                    // console.log(responseEnObjet);

                    // Et on génère le HTML à la volée
                    let chaine = `<table><tbody>`;

                    // Pour 5 photos..
                    for(let i = 0 ; i < 5 ; i++) {
                        let unePhoto = responseEnObjet[i];
                        // .. on crée une ligne et on affiche :)
                        chaine += `<tr>
                            <td><img src="${unePhoto.thumbnailUrl}" /></td>
                            <td>${unePhoto.id} / ${unePhoto.title}</td>
                        </tr>`;
                    }

                    chaine += `</tbody></table>`;

                    loadedContentHTML.innerHTML = chaine;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                });
            break;

        // Besoin d'une inscription gratuite afin de récupérer notre clé API
        // max : c57e6567b8cca9291d66a7f600a4fa12
        case 'meteo':
            // Récupérer le temps actuel
            //      https://openweathermap.org/current

            // Tests
            // ajax('api.openweathermap.org/data/2.5/weather?q={city name}&appid={your api key}')
            // ajax(`https://api.openweathermap.org/data/2.5/weather?q=Paris&appid=${CLE_API_METEO}`)

            //// Construction de la requête à l'API (on peut le faire en une seule fois :p)
            // Url de base
            let requeteAPI = `https://api.openweathermap.org/data/2.5/weather`;
            // Ajout de la ville choisie
            // requeteAPI += `?q=Paris`;

            let inputChoixVilleHTML = document.querySelector('#choixVille');
            let choixville = inputChoixVilleHTML.value;

            requeteAPI += `?q=${choixville}`;
            // Ajout de la clé API
            requeteAPI += `&appid=${CLE_API_METEO}`;
            // Ajout des unités (afin d'avoir des degrés celcius)
            //      https://openweathermap.org/current#data
            requeteAPI += `&units=metric`;
            // Choix de la langue : française
            //      https://openweathermap.org/current#multi
            requeteAPI += `&lang=fr`;


            ajax(requeteAPI)
                .then(function (response) {
                    // Attention, la réponse est en JSON (texte !)
                    // console.log(response);
                    // console.log(typeof response);
                    let responseEnObjet = JSON.parse(response);
                    // console.log(responseEnObjet);

                    // Création des variables intermédiaires
                    let cityName            = responseEnObjet.name;
                    let temperature         = responseEnObjet.main.temp;
                    let leSTempsQuIlFait    = responseEnObjet.weather; // Attenion, c'est un tableau !

                    // Et on génère le HTML à la volée
                    let chaine = `
                        <p>
                            À ${cityName}, 
                            il fait ${responseEnObjet.main.temp}°, 
                            et le temps est `;

                    // Attention, il peut y avoir plusieurs temps de fournis,
                    //  le résultat responseEnObjet.weather sera toujours un objet
                    let chaineTemps = ``;

                    // Pour chaque temps..
                    for(temps of leSTempsQuIlFait) {
                        let description = temps.description;
                        let iconId      = temps.icon;

                        // On ajoute la chaine de caractère correspondante
                        chaineTemps += `${description}`;

                        //// Ajout de l'icône
                        //      https://openweathermap.org/weather-conditions
                        chaineTemps += `
                            <img    alt="weather icon"
                                    src="http://openweathermap.org/img/wn/${iconId}@2x.png"
                                    title="${description}"
                            />
                        `;
                        
                        // avec une virgule et un espace en séparateur
                        chaineTemps += `, `;
                    }

                    // On retire la dernière virgule et le derner espace
                    //      https://developer.mozilla.org/fr/docs/Web/JavaScript/Reference/Objets_globaux/String/substring#Exemples
                    chaineTemps = chaineTemps.substring(0, chaineTemps.length - 2);

                    // On rajoute le/s temps qu'il fait à notre chaîne de caractère
                    chaine += `${chaineTemps}`;
                    
                    // Fermeture de la chaîne
                    chaine += `</p>`;

                    // En enfin on l'ajoute au HTML
                    loadedContentHTML.innerHTML = chaine;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                    console.log(req);
                });
            break;
        
        case 'fox' :
            // https://randomfox.ca/
            ajax('https://randomfox.ca/floof/')
                .then(function (response) {
                    let responseEnObjet = JSON.parse(response);
                    // console.log(responseEnObjet);

                    loadedContentHTML.innerHTML = `
                        <img src="${responseEnObjet.image}" title="A random fox" alt="Random picture of fox" />
                    `;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                });
            break;
        
        case 'rick' :
            // https://rickandmortyapi.com/
            let randomInt = getRandomInt(1, 591);

            ajax(`https://rickandmortyapi.com/api/character/${randomInt}`)
                .then(function (response) {
                    let perso = JSON.parse(response);
                    // console.log(responseEnObjet);

                    loadedContentHTML.innerHTML = `
                        <h3>${perso.name}</h3>
                        <p>${perso.species} ${perso.gender}, from ${perso.origin.name}</p>
                        <img src="${perso.image}" title="${perso.name}" alt="Random picture of rick and morty character" />
                    `;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                });
            break;
        
        case 'pokaymon':
            // On récupère le choix utilisateur
            let choixPokeHTML = document.querySelector('#choixPoke');
            let idPoke        = choixPokeHTML.value;
            
            let requetePoke = 'php/4-pokaymon.php';
            
            // On s'en sert pour créer l'url, si besoin
            if(idPoke !== '') {
                // ~ php/4-pokaymon.php?id=25
                requetePoke += `?id=${idPoke}`;
            }

            ajax(requetePoke)
                .then(function (response) {
                    // Le serveur a correctement répondu
                    // console.log(response);
                    let pokemonsEnObjet = JSON.parse(response);
                    console.log(pokemonsEnObjet);

                    // Si il n'y a qu'un seul pokemon, on le met dans un tableau
                    //  afin de pouvoir réutiliser l'affichage
                    if(idPoke !== '') {
                        pokemonsEnObjet = [ pokemonsEnObjet ];
                    }


                    let chaine = `<table><tbody>`;

                    // Pour 5 photos..
                    for(let i = 0 ; i < pokemonsEnObjet.length ; i++) {
                        let unPokemon = pokemonsEnObjet[i];
                        let urlImage  = `images/pokemons/${unPokemon.id}.png`;

                        chaine += `<tr>
                            <td><img src="${urlImage}" /></td>
                            <td>${unPokemon.id}</td>
                            <td>${unPokemon.name}</td>
                            <td>${unPokemon.type}</td>
                        </tr>`;
                    }

                    chaine += `</tbody></table>`;

                    loadedContentHTML.innerHTML = chaine;
                })
                .catch(function (req) {
                    // console.log(req);
                    // Le serveur n'a pas répondu comme attendu
                    alert(`Erreur lors de l'appel de la ressources`);
                    console.log(req);
                });
            break;

        default:
            // Pas catholique
            alert('Erreur formulaire');
    }
}


// 2. Call promesse
//  Test de l'exemple de grafikart
//      https://www.grafikart.fr/tutoriels/promise-async-await-875 > Les promesses
let ajax = function (url) {
    // On renvoie une promesse qui prend en paramettre une fonction 
    // avec 2 paramètres, le callback de succès et d'erreur
    return new Promise(function (resolve, reject) {
        // Le reste du code ressemble à la méthode précédente
        let req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.onreadystatechange = function (aEvt) {
            if (req.readyState == 4) {
                if(req.status == 200) {
                    resolve(req.responseText);
                }
                else {
                    reject(req);
                }
            }
        };
        req.send(null);
    })
}




let buttonPokeHasardHTML = document.querySelector('#pokeHasard');
buttonPokeHasardHTML.addEventListener('click', onPokehasardButtonClick);

function onPokehasardButtonClick() {
    ajax('php/4-pokaymon.php?random')
        .then(function (response) {
            // Le serveur a correctement répondu
            // console.log(response);
            let pokemonsEnObjet = JSON.parse(response);
            console.log(pokemonsEnObjet);

            // Il n'y a qu'un seul pokemon, on le met dans un tableau
            //  afin de pouvoir réutiliser l'affichage
            pokemonsEnObjet = [ pokemonsEnObjet ];


            let chaine = `<table><tbody>`;

            // Pour 5 photos..
            for(let i = 0 ; i < pokemonsEnObjet.length ; i++) {
                let unPokemon = pokemonsEnObjet[i];
                let urlImage  = `images/pokemons/${unPokemon.id}.png`;

                chaine += `<tr>
                    <td><img src="${urlImage}" /></td>
                    <td>${unPokemon.id}</td>
                    <td>${unPokemon.name}</td>
                    <td>${unPokemon.type}</td>
                </tr>`;
            }

            chaine += `</tbody></table>`;

            loadedContentHTML.innerHTML = chaine;
        })
        .catch(function (req) {
            // console.log(req);
            // Le serveur n'a pas répondu comme attendu
            alert(`Erreur lors de l'appel de la ressources`);
            console.log(req);
        });
}